#include <memory.h>
#include <stdio.h>


#define  BUFFER_SIZE 2048
#define  SECTOR_SIZE 512		// С


unsigned char ucBuffer[BUFFER_SIZE];
unsigned char ucBuffer2[SECTOR_SIZE];

/*
			*ļеֲͼ*
	+-----------------------------------------------+
	|			|			|						|
	| boot   	| 	loader	|		kernel.dll		|
	|			|			|						|
	+-----------------------------------------------+
    0          1-4			5-N
*/

int main(int argc, char* argv[])
{
	//  5
	if(5 != argc)
	{
		printf("mkimage parameter error. \nUsage: mkimage.exe bootsect setup system.\n");
		return 1;
	}
	
	//
	// 򿪾ļ
	//
	FILE *pImageFile = fopen(argv[4], "wb");
	if (NULL == pImageFile)
	{
		printf("Createing %s failed\n", argv[4]);
		return 1;
	}

	//
	// ȡһļ boot.binд뾵ĵ 0 
	//
	FILE *pBootFile = fopen(argv[1], "rb");
	if (NULL == pBootFile)
	{
		printf("Unable to open %s file\n", argv[1]);
		fclose(pImageFile);
		return 1;
	}

	fread(ucBuffer, sizeof(unsigned char), SECTOR_SIZE, pBootFile);
	int iNum = fwrite(ucBuffer, sizeof(unsigned char), SECTOR_SIZE, pImageFile);
	printf("%s ɹд %s! һд %d ֽ \n", argv[1], argv[4], iNum);

	fclose(pBootFile);

	//
	// ȡڶļ loader.binд뾵ĵ 1 - 4 
	//
	// 
	memset(ucBuffer, 0, BUFFER_SIZE);
		
	FILE *pLoaderFile = fopen(argv[2], "rb");
	if (NULL == pLoaderFile)
	{
		printf("Unable to open file %s \n", argv[2]);
		fclose(pImageFile);
		return 1;
	}
	
	fread(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pLoaderFile);
	iNum = fwrite(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pImageFile);
	printf("%s ɹд %s! һд %d ֽ\n", argv[2], argv[4], iNum);

	fclose(pLoaderFile);
	
	//
	// ȡļ kernel.dllӾĵ5ʼд
	//
	// 
	memset(ucBuffer, 0, BUFFER_SIZE);

	FILE *pSystemFile = fopen(argv[3], "rb");
	if(NULL == pSystemFile)
	{
		printf("Unable to open file %s \n", argv[3]);
		fclose(pImageFile);
		return 1;
	}
	
	int i;
	for ( i=0; (iNum = fread(ucBuffer, sizeof(unsigned char), BUFFER_SIZE, pSystemFile)) > 0; i += iNum)
		fwrite(ucBuffer, sizeof(unsigned char), iNum, pImageFile);
	printf("%s ɹд %s! һд %d ֽ\n", argv[3], argv[4], i);
	
	fclose(pSystemFile);

	// ΪBochsҪصľļ512ֽڵҪ㣬kernelļҲ512ֽڵ
	// ΪkernelļС300k˼kernel300kĲȻֽ伴
	unsigned char s = 0;
	int j = 0;
	int fillcount = 307200-i;
	for(; j < fillcount; j++)
	{
		fwrite(&s, sizeof(unsigned char), 1, pImageFile); 
	}

	// Bochs ԼصľСһҪ˽ļдһЩ
	// ļ512
	memset(ucBuffer2, 0, SECTOR_SIZE);
	int m = 0;
	for(; m < 512; m++)
	{
		fwrite(ucBuffer2, 512, 1, pImageFile); 
	}     

	fclose(pImageFile);
	return 0;
}
